#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

#include "Individual.h"
#include "Population.h"
#include "SPEA2ranking.h"
#include "Penalty.h"
#include "MatingSelection.h"
#include "Truncation.h"

#ifndef _ARCHIVE_H_
#define _ARCHIVE_H_

class MatingSelection;
class Population;

//============================================
//	class Archive
//============================================
class Archive{
public:

	Archive(Parameter& para);

	Individual* getobjArchive(int i);
	vector<Individual>& getobjArchive(){
		return objarchive;
	}
	vector<Individual>& getvarArchive(){
		return vararchive;
	}
	Individual* getvarArchive(int i);
	//󥭥󥰡ڥʥƥ꡼¸Ԥ콸Ĥع
	void updateArchive(Population& pop);
	bool getvariableFlag(){
		return variableFlag;
	}
    //ᥤƥˤ꿷õ콸Ĥ
    Population getSearchPopulation();
	
private:
	SPEA2ranking* ranking;
	Penalty* pena;
	MatingSelection* selector;
	Truncation* truncator;
	int archiveSize;	//֥
	int fitness0num;	//fitnessθΤθĿ
	bool variableFlag; //trueΤȤ߷ѿ֤ᥤƥ
	
	void exeranking(Population& pop);	//󥭥
	void penalty(Population& pop);	//ڥʥƥΥå
	void preserveArchive(Population& pop);	//꡼¸
	void truncation(vector<Individual>& fitness0);	//üڤˡ
	void matingSelection(Population& pop);	//ᥤƥ
	vector<Individual> objarchive;	//Ūؿ֥
	vector<Individual> vararchive;	//߷ѿ֥

};
#endif //_ARCHIVE_H_
