#include "Individual.h"

/*
	Τɽ饹
*/
Individual::Individual(){
	parameter = &Parameter::getInstance();
	GAInitializer* ini = new RandomInitializer(parameter->getGeneLength());
	gene = new int[parameter->getGeneLength()];
	ini->createOne(gene,parameter->getGeneLength());
	delete ini;
	objectiveValue = new double[parameter->getObjectiveNum()];

	//
	constraint = new double[parameter->getfunc()->getconstraintNum()];

	mutation = (Mutation *) &NormalMutation::getInstance();
	cross = (Crossover *) &nPointCrossover::getInstance();
	
	isFeasible = true;
}

Individual::Individual(ifstream& fin){
	parameter = &Parameter::getInstance();
	GAInitializer* ini = new RandomInitializer(parameter->getGeneLength());
	gene = new int[parameter->getGeneLength()];

	if(parameter->getFInitialPopulation()){
	  ini->createOneFromFile(gene, parameter->getGeneLength(), fin);
	} else {
	  ini->createOne(gene, parameter->getGeneLength());
	}
	
	delete ini;
	objectiveValue = new double[parameter->getObjectiveNum()];

	//
	constraint = new double[parameter->getfunc()->getconstraintNum()];

	mutation = (Mutation *) &NormalMutation::getInstance();
	cross = (Crossover *) &nPointCrossover::getInstance();
	
	isFeasible = true;
}


//ԡ󥹥ȥ饯
Individual::Individual(const Individual& obj)
{
	parameter = obj.parameter;
	mutation = obj.mutation;
	cross = obj.cross;
	gene = new int[parameter->getGeneLength()];

	objectiveValue = new double[parameter->getObjectiveNum()];

	//
	constraint = new double[parameter->getfunc()->getconstraintNum()];

	copy(obj);
  
};

void Individual::setGene(int* g){
	for(int i=0;i<parameter->getGeneLength();i++){
		gene[i] = g[i];
	}
}

Parameter* Individual::getParameter(){
	return parameter;
}

void Individual::evaluation(){

	Evaluation::getInstance().evaluateOne(*this);

}

void Individual::copy(const Individual& obj)
{
	if(this != &obj){
		parameter = obj.parameter;
		mutation = obj.mutation;
		cross = obj.cross;
		isFeasible = obj.isFeasible;
		fitness = obj.fitness;
		rank = obj.rank;

		setGene(obj.gene);
		setobjective(obj.objectiveValue);
		setconstraint(obj.constraint);
	}
}
//黻
Individual &Individual::operator=(const Individual &obj){
	
	if(this != &obj){
		parent = obj.parent;
		parameter = obj.parameter;
		mutation = obj.mutation;
		cross = obj.cross;
		isFeasible = obj.isFeasible;
		fitness = obj.fitness;
		rank = obj.rank;
		
		delete [] gene;
		gene = new int[parameter->getGeneLength()];
		setGene(obj.gene);
		
		delete [] objectiveValue;
		objectiveValue = new double[parameter->getObjectiveNum()];
		setobjective(obj.objectiveValue);
		
		delete [] constraint;
		constraint = new double[parameter->getfunc()->getconstraintNum()];
		setconstraint(obj.constraint);
	}
	return *this;
}

//ʬobjtrue֤
bool Individual::operator==(const Individual &obj){
	
	for(int i=0;i<parameter->getGeneLength();i++){
		if(gene[i] != obj.gene[i]){
			return false;
		}
	}
	return true;
}

//Ѱ
void Individual::mutate(){
	mutation->mutateOne(*this);
}

//򺵤򤹤
void Individual::crossover(Individual& partner){
	cross->crossover(*this,partner);
}

//indivȤ߷ѿ֤ǤεΥ¬֤
double Individual::getDistanceVariable(Individual& indiv){
	
	double d=0;
	for(int i=0;i<parameter->getGeneLength();i++){
		d += indiv.getGene()[i]^getGene()[i];
	}
	
	return sqrt(d);
}
//indivȤŪؿ֤ǤεΥ¬֤
double Individual::getDistanceObjective(Individual& indiv,double* max,double* min){
	double d=0;
	for(int i=0;i<parameter->getObjectiveNum();i++){
		if(!((max[i]-min[i])==0)){
			d+= pow((indiv.getobjective(i)-getobjective(i))/(max[i]-min[i]),2.0);
		}
	}
	return sqrt(d);
}

//ʬindiv˻ۤƤtrue֤		
bool Individual::bedominated(Individual& indiv){
	int count = 0;
	int same = 0;
	for(int i=0;i<parameter->getObjectiveNum();i++){
		if(objectiveValue[i]>=indiv.getobjective(i)) count++;
		if(objectiveValue[i]==indiv.getobjective(i)) same++;
	}
	if(count==parameter->getObjectiveNum() && same!=parameter->getObjectiveNum()) return true;
	else return false;
}

void Individual::deleteParent(){
	delete parent;
}
//ʬΤintgƱʤtrue֤
bool Individual::equalGene(int* g){
	for(int i=0;i<parameter->getGeneLength();i++){
		if(gene[i] != g[i]){
			return false;
		}
	}
	return true;
}

