#ifndef _INDIVIDUAL_H_
#define _INDIVIDUAL_H_

#include <vector>
#include <cfloat>
#include <cmath>
#include <iostream>
#include <fstream>
using namespace std;

#include "GAInitializer.h"
#include "Parameter.h"
#include "Evaluation.h"
#include "Mutation.h"
#include "Repair.h"
#include "Crossover.h"

/*
	Τɽ饹
*/
class Individual{
public:
	Individual();
    Individual(ifstream& fin);
	Individual(const Individual& obj);

	~Individual(){
		delete [] gene;
		delete [] objectiveValue;
		delete [] constraint;	
	};
	
	int* getGene(){
		return gene;
	}
	
	void setGene(int* g);
	
	Parameter* getParameter();

	double getobjective(int i){
		return objectiveValue[i];
	}
	
	void setobjective(double* objec){
		for(int i=0;i<parameter->getObjectiveNum();i++){
			objectiveValue[i] = objec[i];
		}
	}

	void setconstraint(double* con){
		for(int i=0;i<parameter->getfunc()->getconstraintNum();i++){
			constraint[i] = con[i];
		}
	}
	double getconstraint(int i){
		return constraint[i];
	}
	
	void setrank(int r){
		rank=r;
	}
	void setfitness(double f){
		fitness = f;
	}
	double getfitness(){
		return fitness;
	}
	int getrank(){
		return rank;
	}	

	void setisFeasible(bool b){
		isFeasible = b;
	}
	void setParent(Individual& p){
		
		parent = new Individual(p);
	}

	bool getisFeasible(){
		return isFeasible;
	}
	
	Individual* getParent(){
		return parent;
	}
	//Ѱۤ
	void mutate();
	//ɾ
	void evaluation();
	//partnerȸ򺵤򤹤
	void crossover(Individual& partner);
	//Τä
	void deleteParent();
	
	Individual &operator=(const Individual &obj);
	bool operator==(const Individual &obj);
	bool operator<(const Individual& obj) const		{return fitness < obj.fitness;}
	//Τint礬ޥåtrue
	bool equalGene(int* g);
	//indivȤŪؿ֤ǤεΥ֤
	double getDistanceObjective(Individual& indiv,double* max,double* min);
	//indivȤ߷ѿ֤ǤεΥ֤
	double getDistanceVariable(Individual& indiv);
	//indiv˻ۤƤtrue
	bool bedominated(Individual& indiv);

private:
	Individual* parent;
	Parameter* parameter;
	Mutation* mutation;
	Crossover* cross;
	Repair* repairer;
	//
	int rank;
	//¹Բǽΰ⤫ɤ
	bool isFeasible;
	//Ŭ
	double fitness;

	//
	int* gene;

	//Ūؿ
	double* objectiveValue;

	//
	double* constraint;
	
	void copy(const Individual& obj);
	

};

#endif
